﻿/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Timer tick functions

function OnVaxPhoneIncomingCallBlickTimer() 
{
    m_objVaxPhoneIncomingCall.OnBlinkTick();
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Class cVaxPhoneIncomingCall

function cVaxPhoneIncomingCall()
{
    var m_nBlinkTimer;
        
    this.OnVaxInit = function () 
    {
        
    }

    this.OnVaxUnInit = function () 
    {
        while (ListIncomingCall.length > 0) 
            ListIncomingCall.remove(0);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallStarted = function (sSDP, CallId, DisplayName, UserName, FromURI, ToURI) 
    {
        if (FindCall(CallId) != -1) return;

        if (DisplayName.length != 0)
            AddToCallList("NAME: " + DisplayName + ", CLI: " + UserName, CallId, sSDP);
        else
            AddToCallList("NAME: Unknown" + ", CLI: " + UserName, CallId, sSDP);
    }

    this.OnIncomingCallRingingStart = function (CallId) 
    {
        m_objVaxPhoneTone.OnIncomingCallRingingStart();
        BlinkStart();
    }

    this.OnIncomingCallRingingStop = function (CallId) 
    {
        ItemIndex = FindCall(CallId);
        if (ItemIndex == -1) return;

        RemoveFromCallList(ItemIndex);
        
        m_objVaxPhoneTone.OnIncomingCallRingingStop();
        BlinkStop();
    }
	
	this.OnAcceptCallConnected = function(sToRTPIP, nToRTPPort)
	{
		m_objVaxPhone.AddToPhoneLogList("Success to connect.");
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.BtnAccept_onclick = function () 
    {
	    if (ListIncomingCall.selectedIndex == -1) return;

	    var ValueAccept = ListIncomingCall.options[ListIncomingCall.selectedIndex].value;
	    ValueAccept = ValueAccept.split(",");

	    sCallId = ValueAccept[0];
	    sSDP = ValueAccept[1];

	    

	    m_objVaxPhoneTone.OnIncomingCallAccepted();
	    m_objVaxEventSIP.OnIncomingCallAccepted(sSDP, sCallId);

	    RemoveFromCallList(ListIncomingCall.selectedIndex);

	    BlinkStop();
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

	this.BtnReject_onclick = function () 
    {
        var ValueAccept = ListIncomingCall.options[ListIncomingCall.selectedIndex].value;
        ValueAccept = ValueAccept.split(",");

        sCallId = ValueAccept[0];
        sSDP = ValueAccept[1];

	    m_objVaxFuncSIP.RejectCall(sCallId);
	    m_objVaxPhoneTone.OnIncomingCallRejected();

	    RemoveFromCallList(ListIncomingCall.selectedIndex);
	    BlinkStop();
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function RemoveFromCallList(nIndexList)
    {
        ListIncomingCall.remove(nIndexList);

        if (ListIncomingCall.selectedIndex == -1 && ListIncomingCall.length > 0)
            ListIncomingCall.selectedIndex = 0;
	}

    function AddToCallList(sCallerId, sCallId, sSDP)
    {
		var aValue = [sCallId, sSDP];
		
        ListIncomingCall.options[ListIncomingCall.options.length] = new Option(sCallerId, aValue);

        if (ListIncomingCall.selectedIndex == -1 && ListIncomingCall.length > 0)
            ListIncomingCall.selectedIndex = 0;
			
	}
    
    function FindCall(sCallId) 
    {
        for (ItemIndex = 0; ItemIndex < ListIncomingCall.length; ItemIndex++) 
        {
            if (ListIncomingCall.options[ItemIndex].value == sCallId) 
                return ItemIndex;
        }
        
        return -1;
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function BlinkStart() 
    {
        PhoneTab = document.getElementById("Phone");

        if (PhoneTab.style.display != 'block' && ListIncomingCall.length == 1) 
        {
            m_nBlinkTimer = setInterval("OnVaxPhoneIncomingCallBlickTimer()", 500);
        }
    }

    function BlinkStop() 
    {
        PhoneTab = document.getElementById("Phone");
        if (PhoneTab.style.display != 'block' && ListIncomingCall.length > 0) return;

        clearInterval(m_nBlinkTimer);
        document.getElementById("PhoneTabLink").style.color = "";
    }

    this.OnBlinkTick = function () 
    {
        LinkText = document.getElementById("PhoneTabLink");
        LinkText.style.color = (LinkText.style.color == 'blue' || LinkText.style.color == 'purple' ? 'red' : 'blue');
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////
};