//Class VaxPhoneFuncSIP

var m_hWebSocket;
var m_objCallerName;
var m_objCallerId;
var m_objDialNo;

var m_bConnectedWebRTC = false;

function cVaxPhoneFuncSIP()
{
    var m_sDisplayName = '';
    var m_sUserName = '';

    var m_sAuthLogin = '';
    var m_sAuthPwd = '';

    var m_sDomainRealm = '';
    var m_sServerAddr = '';
    var m_nServerPort = 0;
    var m_bRegister = false;
        
    var m_sConnectionURL = '';
        	
	this.OnLoadPage = function ()
	{
        this.pageReady();
	}

    ////////////////////////////////////////////////////////////////////////////

    this.pageReady = function ()
	{
	    m_objVaxWebRTC.OnPageLoadWebRTC();
	}
    
	this.Connect = function()
	{	
        m_bConnectedWebRTC = false;
        m_objVaxEventSIP.OnWebConnectionTrying();
		
        m_sConnectionURL = EditRTCServerIP.value;
        this.ConnectionWebSocket();
    }

    this.ConnectionWebSocket = function ()
	{
        m_hWebSocket = new WebSocket(m_sConnectionURL);

		m_hWebSocket.onerror = function (error) 
        {
            m_bConnectedWebRTC = false;
            m_objVaxEventSIP.OnWebConnectionFailed("Failed to connect to Server WebRTC.");
        }

        m_hWebSocket.onopen = function (event) 
        {
            m_bConnectedWebRTC = true;

            m_objVaxEventSIP.OnWebConnectionSuccess();
            m_objVaxFuncSIP.OnWebConnectionSuccess();
        }

        m_hWebSocket.onmessage = function (event) 
        {
            m_objVaxEventSIP.OnPhoneEventSIP(event.data);
        }

        m_hWebSocket.onclose = function (event) 
        {
            m_bConnectedWebRTC = false;
            m_objVaxEventSIP.OnWebConnectionClosed();
        }
	}
        
    this.OnWebConnectionSuccess = function()
    {
        this.Initialize(m_sDisplayName, m_sUserName, m_sAuthLogin, m_sAuthPwd, m_sDomainRealm, m_sServerAddr, m_nServerPort);
    }

    this.OnInitialized = function () 
    {
        if (m_bRegister) 
        {
            this.RegisterToProxy(1800);
            this.AutoRegistration(true, -1, 4);
        }

        this.EnableKeepAlive(10);
        m_objVaxWebRTC.ActivateMediaWebRTC();

        m_objVaxMain.OnVaxInit();
    }

    this.OnUnInitialized = function()
    {
        m_objVaxWebRTC.DeactivateMediaWebRTC();
        m_objVaxMain.OnVaxUnInit();
    }
    
	this.VaxOnline = function(sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, bRegister) 
	{
        m_sDisplayName = sDisplayName;
        m_sUserName = sUserName;

        m_sAuthLogin = sAuthLogin;
        m_sAuthPwd = sAuthPwd;

        m_sDomainRealm = sDomainRealm;
        m_sServerAddr = sServerAddr;
        m_nServerPort = nServerPort;

        m_bRegister = bRegister;

        this.Connect();
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////

    this.Initialize = function (sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort)
    {
        var obj = {FuncName: "Initialize", SessionId: "", FuncParam: [sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort]};
        var JsonString = m_objJSON.BuildString(obj);

        this.SendFuncData(JsonString);
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////

    this.VaxOffline = function()
    {
        this.UnInitialize();
        this.OnUnInitialized();
    }

	this.UnInitialize = function()
	{
        var obj = { FuncName: "UnInitialize", FuncParam: [] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);	
	}

	this.ProcessAuthClientSIP = function (sMethod, sRealm, sURI, sNonce, sQop, sOpaque, sStatusCode, sProcessId, sUserInfo)
	{	
        var sLogin = document.getElementById("EditAccountAuthLogin").value;
    	var sPwd = document.getElementById("EditAccountAuthPassword").value;

    	var sCNonce = "";
        
        var arrValues = new Array(2);
        arrValues[0] = sCNonce;

    	var sHash = m_objVaxMd5.DigestCalc(sLogin, sPwd, sRealm, sQop, sNonce, arrValues);

    	sCNonce = arrValues[0];

        var obj = { FuncName: "ProcessAuthClientSIP", FuncParam:[sMethod, sLogin, sRealm, sURI, sNonce, sCNonce, sQop, sOpaque, sHash, sStatusCode, sProcessId, sUserInfo]};
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);	
	}

	this.RegisterToProxy = function (nExpire)
	{
        var obj= { FuncName: "RegisterToProxy", FuncParam: [nExpire] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.UnRegisterToProxy = function()
	{
        var obj = { FuncName: "UnRegisterToProxy", FuncParam: []};
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

    this.DialCall = function (sCallerName, sCallerId, sDialNo) 
    {
	    m_objCallerName = sCallerName;
	    m_objCallerId = sCallerId;
	    m_objDialNo = sDialNo;

	    m_objVaxWebRTC.OfferCreateWebRTC();
	}
	
	this.DisconnectCall = function ()
	{
        var obj = { FuncName: "DisconnectCall", FuncParam: [] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
        m_objVaxWebRTC.CloseConnection();
	}

	this.AcceptCall = function (sSDP, sCallId)
	{	
        var obj = { FuncName: "AcceptCall", FuncParam: [sSDP, sCallId] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.RejectCall = function (sCallId)
	{
        var obj = { FuncName: "RejectCall", FuncParam: [sCallId] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.TransferCallBlind = function (sToUserName)
	{
        var obj = { FuncName: "TransferCallBlind", FuncParam: [sToUserName] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.EnableKeepAlive = function (nSeconds)
	{
        var obj = { FuncName: "EnableKeepAlive", FuncParam: [nSeconds] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString); 
	}

	this.DisableKeepAlive = function()
	{
        var obj = { FuncName: "DisableKeepAlive", FuncParam: [] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
		
	this.DigitDTMF = function(sDigit)
	{
        var obj = { FuncName: "DigitDTMF", FuncParam: [sDigit] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ForceDigitDTMF = function(nTypeId, bEnable)
	{
        var obj = { FuncName: "ForceDigitDTMF", FuncParam: [nTypeId, bEnable] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
	
	this.DonotDisturb = function (bEnable)
	{
        var obj = { FuncName: "DonotDisturb", FuncParam: [bEnable] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
		
	this.SetSessionLostTick = function (nSeconds)
	{
        var obj = { FuncName: "SetSessionLostTick", FuncParam: [nSeconds] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.SetUserAgentSIP = function (sUserAgentName)
	{
        var obj = { FuncName: "SetUserAgentSIP", FuncParam: [sUserAgentName] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.SetSubjectSDP = function (sSubjectSDP)
	{
        var obj = { FuncName: "SetSubjectSDP", FuncParam: [sSubjectSDP] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatFindContact = function (sUserName)
	{
        var obj = { FuncName: "ChatFindContact", FuncParam: [sUserName] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatAddContact = function (sUserName, bPresence)
	{
        var obj = { FuncName: "ChatAddContact", FuncParam: [sUserName, bPresence] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatRemoveContact = function (sUserName)
	{
        var obj = { FuncName: "ChatRemoveContact", FuncParam: [sUserName] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatSendMessageTyping = function (sUserName, nUserValue32bit)
	{
        var obj = { FuncName: "ChatSendMessageTyping", FuncParam: [sUserName, nUserValue32bit] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatSendMessageText = function (sUserName, sMsgText, nMsgType, nUserValue32bit)
	{
        var obj = { FuncName: "ChatSendMessageText", FuncParam: [sUserName, sMsgText, nMsgType, nUserValue32bit] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatSubscribeContactAll = function()
	{
        var obj = { FuncName: "ChatSubscribeContactAll", FuncParam: [] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ChatSetMyStatus = function (nStatusId)
	{
        var obj = { FuncName: "ChatSetMyStatus", FuncParam: [nStatusId] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.VoiceChanger = function (nPitch)
	{
        var obj = { FuncName: "VoiceChanger", FuncParam: [nPitch] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.ForwardCall = function (bEnable, sToUserName)
	{
        var obj = { FuncName: "ForwardCall", FuncParam: [bEnable, sToUserName] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.AddCustomHeader = function (nReqId, sName, sValue)
	{
        var obj = { FuncName: "AddCustomHeader", FuncParam: [nReqId, sName, sValue]};
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.RemoveCustomHeader = function (nReqId, sName)
	{
        var obj = { FuncName: "RemoveCustomHeader", FuncParam: [nReqId, sName]};
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.RemoveCustomHeaderAll = function (nReqId) 
	{
        var obj = { FuncName: "RemoveCustomHeaderAll", FuncParam: [nReqId] };
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}

	this.AutoRegistration = function (bEnable, nTickCountLimit, nTickSeconds)
	{
        var obj = { FuncName: "AutoRegistration", FuncParam: [bEnable, nTickCountLimit, nTickSeconds]};
    	var JsonString = m_objJSON.BuildString(obj);

    	this.SendFuncData(JsonString);
	}
	
	this.PostRingingMsg = function ()
	{
        var obj = { FuncName: "PostRingingMsg", FuncParam: [0] };
    	var JsonString = m_objJSON.BuildString(obj);
		
    	this.SendFuncData(JsonString);
	}
    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

	this.SendFuncData = function (sData) 
	{
        m_hWebSocket.send(sData);
	}
	
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    this.OnOfferCreatedSuccessWebRTC = function (sLocalSDP) 
    {
        var obj = { FuncName: "DialCall", FuncParam: [sLocalSDP, m_objCallerName, m_objCallerId, m_objDialNo]  };
    	var JsonString = m_objJSON.BuildString(obj);
                
    	m_objVaxFuncSIP.SendFuncData(JsonString);
    }

    this.OnOfferCreatedFailedWebRTC = function (error) 
    {
        ShowDialog("Failed to create offer: " + error.toString());
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}